<template>
<!--调查询问通知书-->
  <el-main style="overflow: hidden">
  <el-form ref="form" :model="form" :label-width="formLabelWidth" :disabled="isFinish=='2'">
    <el-form-item label="文号">
      <el-input v-model="form.unitName" placeholder="______罚询通字〔    〕第  号"></el-input>
    </el-form-item>
    <el-form-item label="当事人姓名或名称">
      <el-input v-model="form.askdPersion"></el-input>
    </el-form-item>

    <el-form-item label="违规行为">
      <el-input type="textarea" :row="2" v-model="form.breakLowContent"></el-input>
    </el-form-item>
    <el-row>
      <el-col :span="12">
        <el-form-item label="违反法律条例">
          <el-autocomplete
            v-model="form.lows"
            filterable
            style="width: 100%"
            :fetch-suggestions="querySearchHandle"
            placeholder="请输入内容"
            :trigger-on-focus="false"
            @select="handleSelect"
          >
          </el-autocomplete>
        </el-form-item>
      </el-col>
      <el-col :span="12">
        <el-form-item label="条" :label-width="formLabelWidth">
          <el-select v-model="form.tiao" filterable placeholder="请选择条" style="width: 100%">
            <el-option
              v-for="item in lawTiaoList"
              :label="item.lawTiaoName"
              :value="item.lawTiaoName"
            >
            </el-option>
          </el-select>
        </el-form-item>
      </el-col>
    </el-row>

<el-row>
  <el-col :span="12">
    <el-form-item label="承办机构">
      <el-input v-model="form.askdAdress"></el-input>
    </el-form-item>
  </el-col>
  <el-col :span="12">
    <el-form-item label="通知时间">
      <el-date-picker
        v-model="form.askdTime"
        type="datetime"
        :value-format="`yyyy-MM-dd HH:mm:ss`"
        placeholder="选择日期"
        style="width: 100%"
      >
      </el-date-picker>
    </el-form-item>
  </el-col>
</el-row>

    <el-form-item class="xieDai" label="携带资料:">
      <el-checkbox-group v-model="form.takeEvidences">
        <el-checkbox label="0" name="type">被调查（询问）人是自然人的，携带身份证原件及复印件。</el-checkbox>
        <el-checkbox label="1" name="type">
          被调查（询问）人是个体工商户（有字号）或者法人或者其他组织的，携带单位营业
          <p>执照、法定代表人的身份证原件及复印件和身份证明，委托他人接受询问的，还应</p>
          <p>当携带受托人身份证原件及复印件和授权委托书。</p>
        </el-checkbox>
        <el-checkbox label="2" name="type">
          <el-input class="textType" type="textarea" v-model="form.takeEvidenceOthers" placeholder="请输入其他内容" style="width: 34vw!important;"></el-input>
        </el-checkbox>
      </el-checkbox-group>

    </el-form-item>
    <el-row>
      <el-col :span="12">
        <el-form-item label="联系人">
          <el-input v-model="form.linkMan"></el-input>
        </el-form-item>
      </el-col>
      <el-col :span="12">
        <el-form-item label="联系电话">
          <el-input v-model="form.linkPhone"></el-input>
        </el-form-item>
      </el-col>
    </el-row>

    <el-row>
      <el-col :span="12">
        <el-form-item label="违规时间">
          <el-date-picker
            v-model="form.breakLowTime"
            type="date"
            :value-format="`yyyy-MM-dd`"
            placeholder="选择日期"
            style="width: 100%"
          >
          </el-date-picker>
        </el-form-item>
      </el-col>
      <el-col :span="12">
        <el-form-item label="扣章日期">
          <el-date-picker
            v-model="form.issuingDate"
            type="date"
            :value-format="`yyyy-MM-dd`"
            placeholder="选择日期"
            style="width: 100%"
          >
          </el-date-picker>
        </el-form-item>
      </el-col>
    </el-row>

    <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
  </el-form>
    <div style="text-align: center">
      <el-button v-if="isFinish!='2'"  plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-if="isFinish!='2'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
import {getLaw,lawInfo} from '@/api/lawList/lawList';
import {getObj,saveObj} from '@/api/News/processAjNotice'
import moment from "moment";
import WordView from '@/views/News/word-view/index'
export default {
  name: "Notice-of-inquiry",
  props: ['isShowYulan','id','isFinish','processId'],
  components:{
    WordView
  },
  data() {
    return {
      showView:false,
      form: {
        registerState:'',
        unitName: '',//单位简称
        askdPersion: '',//当事人姓名或单位
        breakLowTime: '',//违规时间
        breakLowContent: '',//违规行为
        lows: '',//违反法律条例
        tiao:'',
        askdTime: '',//通知时间
        askdAdress: '',//承办机构
        takeEvidenceOthers: '',//其他内容
        takeEvidences: [],
        linkMan: '',//联系人
        linkPhone: '',//联系电话
        issuingDate: '',//扣章日期
      },
      lawList: [],
      lawTiaoList: [],
      formLabelWidth: "140px"
    }
  },
  created() {
    this.init()
  },
  methods: {
    init() {
      getObj(this.id).then((res) => {
        if (res.data.code == 0) {
          // 转换null为""
          // let v = res.data.data;
          // for (let attr in v) {
          //   if (v[attr] == null) {
          //     v[attr] = "";
          //   }
          // }
          // let str = JSON.stringify(v);
          // let data = JSON.parse(str);
          this.form = res.data.data;
        }
      });
    },
    querySearchHandle(queryString, cb) {  //模糊搜素
      getLaw(queryString).then(res => {
        this.lawList = []
        let resultList = res.data.data
        resultList.forEach(item => {
          this.lawList.push({
            value: item.name,
            id: item.id
          })
        })
        cb(this.lawList)
      })
    },
    handleSelect(item) {
      this.form.lows = item.value
      this.form.lawId = item.id
      lawInfo(item.value).then(res => {
        this.lawTiaoList = res.data.data
      })
    },
    dataFormSubmit(type) {
      console.log(type)
      this.$refs['form'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                if (res.data.code == 0) {
                  obj.$message.success('操作成功');
                  obj.cancel();
                  obj.$emit('getDataList');
                }
              })
            })
          } else {
            obj.form.registerState = type;
            obj.form.registerId = obj.id;
            obj.form.processId = obj.processId;
            saveObj(obj.form).then((res) => {
              // this.submitLoading = false;
              if (res.data.code == 0) {
                obj.$message.success("操作成功");
                obj.cancel();
                obj.$emit('getDataList');
              }
            })
          }
        }
      })
    },
    cancel() {
      this.$emit('cancel', false);
    },
    cancelWord() {
      this.showView = false;
    },
    viewVord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/dcxwtzs.docx");
      })
    },
    downloadWord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      let wordData = this.transforData(data);
      WordView.methods.exportDoc(wordData, "/wordes/dcxwtzs.docx", "调查询问通知书.docx");
    },
    transforData(obj) {
      let s = JSON.stringify(obj);
      let data = JSON.parse(s);

      let str = data.takeEvidences;
      if (str.indexOf("0") >= 0){
        data.zi = true;
        data.ran = false;
      }else {
        data.zi = false;
        data.ran = true;
      }
      if (str.indexOf("1") >= 0){
        data.ge = true;
        data.ti = false;
      }else {
        data.ge = false;
        data.ti = true;
      }
      if (str.indexOf("2") >= 0){
        data.qi = true;
        data.ta = false;
      }else {
        data.qi = false;
        data.ta = true;
      }
      if (data.breakLowTime != '' && data.breakLowTime != null) {
        data.breakLowTime = moment(data.breakLowTime).format('YYYY年MM月DD日');
      }else {
        data.breakLowTime = '  年  月  日'
      }
      if (data.askdTime != '' && data.askdTime != null) {
        data.askdTime = moment(data.askdTime).format('YYYY年MM月DD日HH时mm分');
      }else {
        data.breakLowTime = '  年  月  日  时  分'
      }
      if (data.issuingDate != '' && data.issuingDate != null) {
        data.issuingDate = moment(data.issuingDate).format('YYYY年MM月DD日');
      }else {
        data.issuingDate = '  年  月  日'
      }

      return data;
    }
  }
}
</script>

<style lang="scss" scoped>
/*.xieDai{
  position: relative;
  .textType{
position: absolute;
    left: 0;
    top: 50%!important;
  }
}*/
</style>
